<?php
class Funciones {
    private $mesCompleto = array("00"=>"", "01"=>"Enero", "02"=>"Febrero", "03"=>"Marzo"
        , "04"=>"Abril", "05"=>"Mayo", "06"=>"Junio", "07"=>"Julio", "08"=>"Agosto"
        , "09"=>"Septiembre", "10"=>"Octubre", "11"=>"Noviembre", "12"=>"Diciembre");
    private $mesCorto = array("00"=>"", "01"=>"Ene", "02"=>"Feb", "03"=>"Mar", "04"=>"Abr"
        , "05"=>"May", "06"=>"Jun", "07"=>"Jul", "08"=>"Ago", "09"=>"Sep", "10"=>"Oct"
        , "11"=>"Nov", "12"=>"Dic");
    
    public function replace_form($html, $variable, $valor) 
    {	for($i = 0; $i<count($variable); $i++)
        {   $html = str_replace($variable[$i],$valor[$i],$html);
        }
        return $html;
    }
    
    public function getEstadoEstilo($id)
    {   $mensaje = "<span class=\"label label-";
        if($id == "1")
            $mensaje .= "success\">Activo";
        else
            $mensaje .= "important\">Inactivo";
        $mensaje .= "</span>";
        return $mensaje;        
    }
    
    public function getFechaDMY($fecha, $tipo = NULL, $forma = NULL)
    {   $u = ($forma=='1')?"/":"-";
        switch($tipo)
        {   case "1": //Dia Mes y Ao
                $fecha = date("d-m-Y",strtotime($fecha));
                $aux = explode("-",$fecha);
                $fecha = $aux[0]."&nbsp;".$this->mesCorto[$aux[1]]."&nbsp;".$aux[2];
                break;
            case "2": //Dia Mes y Ao
                $fecha = date("d-m-Y",strtotime($fecha));
                $aux = explode("-",$fecha);
                $fecha = $aux[0]."&nbsp;".$this->mesCorto[$aux[1]];
                break;
            default:
                $fecha = date("d".$u."m".$u."Y",strtotime($fecha)); 
                break;    
            
        }
        return $fecha;     
    }
    public function getFechaYMD($fecha)
    {   $fec = explode("-", $fecha);
        return $fec[2]."-".str_pad($fec[1],2,"0",STR_PAD_LEFT)."-".$fec[0];    }
    public function diasMes($mes, $anio) {
       return date("d",mktime(0,0,0,$mes+1,0,$anio));
    }
    function mesNombreCompleto($mes)
    {   return $this->mesCompleto[str_pad($mes,2,"0",STR_PAD_LEFT)];    }
    function mesNombreCorto($mes)
    {   return $this->mesCorto[str_pad($mes,2,"0",STR_PAD_LEFT)];    }
    
    public function getOption($datos, $id = NULL)
    {   $opciones = "";
		foreach ($datos as $row)
		{	$opciones .= "<option ";
			$opciones .= ($id == $row[0])?"selected='selected'":"";
			$opciones .= " value='".$row[0]."'>";
			$opciones .= htmlentities($row[1]);
			$opciones .= "</option>";
		}
		return $opciones;
    }
    
    public function getDataAnio($anioI,$anioF = NULL)
    {   $datos = array(); $anioF = ($anioF==NULL)?date("Y",time()):$anioF;
        $anioI = ($anioI==NULL)?date("Y",time()):$anioI;
        for($i=$anioF; $i>=$anioI; $i--) $datos[] = array($i, $i);
        return $datos;
    }
    
    public function getDataMes()
    {   $datos = array(); 
        for($i=1; $i<=12; $i++) $datos[] = array($i, $this->mesCompleto[str_pad($i,2,"0",STR_PAD_LEFT)]);
        return $datos;
    }
    
    public function sexoNombre($sexo)
    {   
        return ($sexo=="M")?"Masculino":"Femenino";
    }
    
    public function bisiesto($anio_actual)
    {	
        $bisiesto=false;  
        if (checkdate(2,29,$anio_actual)) 
            $bisiesto=true; 
            
        return $bisiesto;
    }
    
    public function calculo_edad($fecha_de_nacimiento, $fecha_actual, $tipo = NULL )
    {   $array_aux1 = explode ( " ", $fecha_de_nacimiento );
        $array_nacimiento = explode ( "-", $array_aux1[0] ); 
        $array_aux2 = explode ( " ", $fecha_actual );
        $array_actual = explode ( "-", $array_aux2[0] ); 
        $anos =  $array_actual[0] - $array_nacimiento[0]; // calculamos aos 
        $meses = $array_actual[1] - $array_nacimiento[1]; // calculamos meses 
        $dias =  $array_actual[2] - $array_nacimiento[2]; // calculamos das
        
        //ajuste de posible negativo en $das 
        if ($dias < 0) 
        {   --$meses;     
            //ahora hay que sumar a $dias los dias que tiene el mes anterior de la fecha actual 
            switch ($array_actual[1]) { 
                   case 1:     $dias_mes_anterior=31; break; 
                   case 2:     $dias_mes_anterior=31; break; 
                   case 3:  
                        if ($this->bisiesto($array_actual[0])) 
                        { 
                            $dias_mes_anterior=29; break; 
                        } else { 
                            $dias_mes_anterior=28; break; 
                        } 
                   case 4:     $dias_mes_anterior=31; break; 
                   case 5:     $dias_mes_anterior=30; break; 
                   case 6:     $dias_mes_anterior=31; break; 
                   case 7:     $dias_mes_anterior=30; break; 
                   case 8:     $dias_mes_anterior=31; break; 
                   case 9:     $dias_mes_anterior=31; break; 
                   case 10:     $dias_mes_anterior=30; break; 
                   case 11:     $dias_mes_anterior=31; break; 
                   case 12:     $dias_mes_anterior=30; break; 
            }     
            $dias = $dias + $dias_mes_anterior;
            $dias = ($dias<0)?0:$dias;     
        }     
        //ajuste de posible negativo en $meses 
        if ($meses < 0) 
        { 
            --$anos; 
            $meses=$meses + 12; 
        } 
        
        $letraTipo = array(" a", " m", " d");
        if($tipo=="CRED" or $tipo=="SUPLE")   $letraTipo = array(" ANIO", " MES", " DIA");
        
        if($anos>0)
            $edad = $anos.$letraTipo[0];
        else
            if($meses>0)
                $edad = $meses.$letraTipo[1];
            else
                $edad = $dias.$letraTipo[2];
        
        switch($tipo)
        {   case "CRED":
                if($anos>0 && $anos<5)
                    $meses = ($anos*12 + $meses);
                $edad = $meses; $nomen = "MES";
                if($meses<1 AND $anos==0) 
                {   $edad = $dias;  $nomen = "DIA";     }
                elseif ($anos>=5)
                {   $edad = $anos;  $nomen = "ANIO";    }
                  
                $edad = array($edad." ".$nomen,$edad,$nomen);               
              break;
	        case "SUPLE":
                if($anos>0 && $anos<100)
                    $edad = ($anos*12 + $meses)." MES";                    
                break;	
            case "DIAS":
                $dias	= (strtotime($fecha_de_nacimiento)-strtotime($fecha_actual))/86400;
                $dias 	= abs($dias); $dias = floor($dias);
                $nomen = ($dias<=1)?"DIA":"DIAS";
                $edad = array($dias." ".$nomen,$dias,$nomen);
                break;
            case "MESES":
                if($anos>0)
                    $meses = ($anos*12 + $meses);
                $nomen = ($meses<=1)?"MES":"MESES";
                $edad = array($meses." ".$nomen,$meses,$nomen);
                break;
            case "ANIOS":    
                $nomen = ($anos<=1)?"ANIO":"ANIOS";
                $edad = array($anos." ".$nomen,$anos,$nomen);                
              break;
            case "SEMANAS":                
                $datetime1 = new DateTime($fecha_de_nacimiento); $datetime2 = new DateTime($fecha_actual);
                $interval = $datetime1->diff($datetime2);   $dias = $interval->format('%a');
                $semanas = floor($dias/7);  $nomen = ($semanas<=1)?"SEMANA":"SEMANAS";
                //$semanas = str_pad($semanas,2,"0",STR_PAD_LEFT);
                $edad = array($semanas." ".$nomen,$semanas,$nomen);
              break;
            case "COMPLETO":
                $edad  =     $anos.$letraTipo[0];
                if($meses<10) $meses = "0".$meses;
                $edad .= ", ".$meses.$letraTipo[1];
                if($dias<10) $dias = "0".$dias;
                $edad .= ", ".$dias.$letraTipo[2];                
                break;  
            case "MEDIO":
                $edad  = ($anos<1)?"":($anos.$letraTipo[0].", ");
                if($meses<10) $meses = "0".$meses;
                $edad .= $meses.$letraTipo[1];
                if($anos<1)
                {   if($dias<10) $dias = "0".$dias;
                    $edad .= ", ".$dias.$letraTipo[2];
                }
                break;            
        }       
                      
        return $edad;
    }
}
?>
